def tipDataCalend = 'Date'
def tipNumeric = 'Number'
def tipString = 'String'
def spatiiStangaMsg = "..."

/* Nu este necesara definirea variabilelor "locale", "idFirma", "idUser",
   deoarece acestea sunt deja injectate ca proprietate. */

def stringFormat = "dd.MM.yyyy"

if (debug) {
   println("Parametrii: " + parameters[])
   println("Parametru 'insert': " + parameters['insert'])
}

def insert = parameters['insert']
def fileNomArt = files['nomArt']

def numeFisErr = 'Erori.xlsx'

def inregTotale = 0
def inregAdaugate = 0
def inregNecorespunzatoare = 0
def randuriIgnorate = 0


def suntErr = false
def suntWrn = false

def fields = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomQueryBuilder", "getColumnLabels", [locale]).remoteSimpleObject

if (debug) {
   println("Campurile: ${fields}")
}

def cloneWb = null
def cloneSheet = null
def liniiOK = []
def mesajeList = []

def style = null


// fisierul html cu mesajele de eroare + concluzia de la incercarea de preluare
def fisRezSB = new StringBuilder()
fisRezSB<<"<html><body>"

File fisRezFile = new File(tmpFolder, "blabla.txt")
fisRezFile.createNewFile()

fisRezSB<<"</body></html>"

def errLipsaFileNomArt = (fileNomArt == null || fileNomArt == '')
def errFormatEronatFileNomArt = false

if (errLipsaFileNomArt) {
   fisRezSB<<"<li>"
   fisRezSB<<"Campul <mark><b>Fisier XLS conform model (NomArt.xlsx)</b></mark>:"
   
   fisRezSB<<"<br>"
   fisRezSB<<"Eroare:"
   
   fisRezSB<<"<br>"
   fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> In camp nu este incarcat niciun fisier cu date de preluat."
   
   fisRezSB<<"<br>"
   fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Fisierul este obligatoriu!"
   fisRezSB<<"</li>"
   
   fisRezSB<<"<br>"
}


if (errLipsaFileNomArt == false) {
   try {
      excelReader.iterateRow(fileNomArt, 1, true, {reader ->
         int rowNo = reader.rowNo
         int nrRandDeAfisat = rowNo + 1 /* deoarece Randurile si Coloanele se numara de la zero */
         
         String sheetName = reader.sheetName
         
         if (debug) {
            println("excelReader.iterateRow --> rowNo: ${rowNo}")
                    // Am pus acest mesaj de debug pt. cazul in care in fisier exista
                    // randuri necompletate care, din motive inca necunoscute,
                    // sunt "sarite" de la prelucrare
                    // (cum este cazul randurilor 24, 25, 26 din fisierul model "NomArt.xlsx", depus in .SVN
                    //  in calea http://svn.emsys.ro/viewvc/STARTUP_ERP/trunk/Clienti/Stocuri/0200.NomArt,
                    //  Revizii 970 / 17.09.2021, 984 / 24.09.2021).
         }
         
         if (cloneSheet == null) {
            cloneWb = reader.cloneWorkBook()
            cloneSheet = cloneWb.getSheet(sheetName)
            style = cloneWb.createCellStyle()
            style.setBorderBottom(BorderStyle.MEDIUM)
            style.setBottomBorderColor(IndexedColors.RED.getIndex())
            style.setBorderLeft(BorderStyle.MEDIUM)
            style.setLeftBorderColor(IndexedColors.RED.getIndex())
            style.setBorderRight(BorderStyle.MEDIUM)
            style.setRightBorderColor(IndexedColors.RED.getIndex())
            style.setBorderTop(BorderStyle.MEDIUM)
            style.setTopBorderColor(IndexedColors.RED.getIndex())
         }
         
         def rowContext = [:]
         def rowFieldContext = [:]
         
         StringBuilder msgsErrorGetVal = new StringBuilder()
         def existaMsgsErrorGetVal = false
         
         /* --> Definire closure "completeazaMap" */
         def completeazaMap = {String numeColoanaXLS, String fieldEmsys, String dataType, int nrZec = 0 ->
            def val = null
            def errorGetVal = null
            def msgErrorGetVal = null
            
            switch(dataType) {
             case tipDataCalend:
              try {
                 val = reader.getDate(numeColoanaXLS, 'dd.MM.yyyy')
              } catch (error) {
                 errorGetVal = error
              }
              
              if (errorGetVal != null) {
                 errorGetVal = null
                 
                 try {
                    val = reader.getDate(numeColoanaXLS, 'dd/MM/yyyy')
                 } catch (error) {
                    errorGetVal = error
                 }
              }
              
              if (errorGetVal != null) {
                 errorGetVal = null
                 
                 try {
                    val = reader.getDate(numeColoanaXLS, 'dd-MM-yyyy')
                 } catch (error) {
                    errorGetVal = error
                 }
              }
              
              break
             
             case tipNumeric:
              try {
                 val = reader.getNumber(numeColoanaXLS)
                 if (val != null) {
                    val = val.setScale(nrZec, RoundingMode.HALF_UP)
                 }
              } catch (error) {
                 errorGetVal = error
              }
              break
             
             case tipString:
              try {
                 val = reader.getString(numeColoanaXLS)
              } catch (error) {
                 errorGetVal = error
              }
              break
             
             default:
              break
            }
            
            def poz = reader.findPosition(numeColoanaXLS)
            def clonedRow = cloneSheet.getRow(rowNo)
            def content = ['cell':poz, 'field':fieldEmsys, 'xlsField':numeColoanaXLS, 'value':val, 'poiCell':clonedRow.getCell(poz)]
            rowContext.put(numeColoanaXLS, content)
            rowFieldContext.put(fieldEmsys, content)
            
            if (debug) {
               println("poz ${poz} - ${numeColoanaXLS}: ${fieldEmsys} - ${val} - ${(val == null) ? null : val.class} - ${errorGetVal}")
            }
            
            if (errorGetVal != null) {
               if (existaMsgsErrorGetVal == false) {
                  msgsErrorGetVal<<"<u>Citirea valorilor de pe rand</u>:"
               } else {
                  msgsErrorGetVal<<"<br>"
                  msgsErrorGetVal<<" "
               }
               
               switch(dataType) {
                case tipDataCalend:
                 msgErrorGetVal = "valoarea din celula (<b>${content.poiCell}</b>) nu poate fi citita corect ca <b>Data Calendaristica</b><br><span style=\"color:White;\">${spatiiStangaMsg}</span> in niciunul din formatele: <b>dd.MM.yyyy</b>, <b>dd/MM/yyyy</b>, <b>dd-MM-yyyy</b> (unde <b>dd</b> = ziua cu 2 cifre, <b>MM</b> = luna cu 2 cifre, <b>yyyy</b> = anul cu 4 cifre)"
                 break
                
                case tipNumeric:
                 msgErrorGetVal = "valoarea din celula (<b>${content.poiCell}</b>) nu poate fi citita corect ca <b>Numar</b>"
                 break
                
                case tipString:
                 msgErrorGetVal = "valoarea din celula (<b>${content.poiCell}</b>) nu poate fi citita corect ca <b>Sir de Caractere</b>"
                 break
                
                default:
                 break
               }
               
               msgsErrorGetVal<<"<br>"
               msgsErrorGetVal<<"Eroare la campul <b>${content.xlsField}</b> (coloana <b>${content.cell + 1}</b>):"
               
               msgsErrorGetVal<<"<br>"
               msgsErrorGetVal<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> ${msgErrorGetVal}"
               
               msgsErrorGetVal<<"<br>"
               msgsErrorGetVal<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> (valoare citita <b>${content.value}</b>: <span style=\"color:DarkGrey;\">${errorGetVal}</span>)."
               
               def rowField = rowFieldContext[fieldEmsys]
               
               if (rowField != null) {
                  if (debug) {
                     println("rowField.poicell (la citire valori rand): ${rowField.poiCell}")
                  }
                  
                  def varPoicell = rowField.poiCell
                  
                  if (debug) {
                     println("varPoicell (la citire valori rand): ${varPoicell}")
                  }
                  
                  if (varPoicell != null) {
                     varPoicell.setCellStyle(style)
                  }
               }
               
               existaMsgsErrorGetVal = true
            }
            
            return content
         }
         /* <-- Definire closure "completeazaMap" */
         
         def codart = completeazaMap("Cod", 'codart', tipString).value
         def numeart = completeazaMap("Denumire", 'numeart', tipString).value
         def codUm = completeazaMap("UM", 'codUm', tipString).value
         def codGrupa = completeazaMap("Grupa", 'codGrupa', tipString).value
         def codSubgrupa = completeazaMap("Subgrupa", 'codSubgrupa', tipString).value
         def codartEtalon = completeazaMap("Cod articol etalon", 'codartEtalon', tipString).value
         def codTvaVnz = completeazaMap("CotaTVA", 'codTvaVnz', tipString).value
         
         def stocsig = completeazaMap("Stoc siguranta", 'stocsig', tipNumeric, 3).value
         
         def tipCod = completeazaMap("Tip cod de bare", 'tipCod', tipString).value
         def codbare = completeazaMap("Cod de bare", 'codbare', tipString).value
         def codUmVolum = completeazaMap("UmVolum", 'codUmVolum', tipString).value
         
         def volum = completeazaMap("Volum", 'volum', tipNumeric, 3).value
         
         def codUmColet = completeazaMap("Um Greutate", 'codUmColet', tipString).value
         
         def grbruta = completeazaMap("Greutate bruta", 'grbruta', tipNumeric, 3).value
         def grneta = completeazaMap("Greutate neta", 'grneta', tipNumeric, 3).value
         
         def lotizat = completeazaMap("Lotizat", 'lotizat', tipString).value
         
         def zileraft = completeazaMap("Zile Valabilitate", 'zileraft', tipNumeric, 0).value
         
         def cantaribil = completeazaMap("Se cantareste", 'cantaribil', tipString).value
         def codPart = completeazaMap("Furnizor principal", 'codPart', tipString).value
         def tipTvaVnz = 'TVA'
         def optext = completeazaMap("Accepta Denumire Extinsa", 'optext', tipString).value
         def argsNomFind = [codartEtalon, idFirma]
         
		 if(!optext?.trim()){
		   optext = 'DA'
		 }
         if (debug) {
            println("Cod Articol Etalon: " + codartEtalon)
         }
         
         inregTotale++
         
         def returnTemplate =
                   jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomService", "findNomRow", argsNomFind)
         def template = returnTemplate.remoteRowObject
         
         if (debug) {
            println("Obiectul Nom pt. Articolul Etalon: " + template)
         }
         
         if (template == null) {
            suntErr = true
            inregNecorespunzatoare++
            StringBuilder msgs = new StringBuilder()
            
            msgs<<"<mark>Set mesaje nr. <b>${randuriIgnorate + inregNecorespunzatoare}</b></mark> - Rand nr. <b>${nrRandDeAfisat}</b> / <b>${nrRandDeAfisat}</b>, Sheet (foaie) <b>${sheetName}</b>, fisier cu date de preluat / fisier <b>${numeFisErr}</b>:"
            
            msgs<<"<br>"
            msgs<<"<u>Verificare Articol Etalon (completare in fisier si existenta in Baza de Date)</u>:"
            
            msgs<<"<br>"
            msgs<<"Eroare:"
            
            msgs<<"<br>"
            
            if (codartEtalon == null) {
               msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Cod articol etalon: Valoare obligatorie. Celelalte informatii din fisier pot fi validate numai dupa ce in acest camp este scrisa o valoare corecta."
            } else {
               msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Cautare Articol Etalon: Articolul cu codul ${codartEtalon} nu exista. Celelalte informatii din fisier pot fi validate numai dupa ce in acest camp este scrisa o valoare corecta."
            }
            
            mesajeList<<msgs.toString()
            
            if (debug) {
               println("Verificare Articol Etalon (completare in fisier si existenta in Baza de Date)")
               println("rowContext: ${rowContext}")
               println("rowContext: ${rowContext["Cod articol etalon"].poiCell}")
               println("rowFieldContext: ${rowFieldContext}")
            }
            
            def varPoicell = rowContext["Cod articol etalon"].poiCell
            
            if (varPoicell != null) {// Am pus aceasta conditie pt. a evita exceptia
                                     //   com.prodinf.core.util.groovy.ExcelReaderException:  Exception ::Cannot invoke method setCellStyle() on null object
                                     // care apare daca in fisier nu este completata coloana "Cod articol etalon".
               varPoicell.setCellStyle(style)
            }
            
            return
         }
         
         def mapNom = [:]
         mapNom<<returnTemplate.remoteSimpleObject
         mapNom<<[
                  'idFirma' : idFirma,
                  'idUseradg' : idUser,
                  'idUserdef' : idUser,
                  'datadef' : new java.util.Date(),
                  
                  'codart' : codart,
                  'numeart' : numeart,
                  'numesort' : numeart?.take(60),
                  'codUm' : codUm,
                  'codGrupa' : codGrupa,
                  'codSubgrupa' : codSubgrupa,
                  'codartEtalon' : codartEtalon,
                  'codTvaVnz' : codTvaVnz,
                  'tipTvaVnz' : tipTvaVnz,
                  'stocsig' : stocsig,
                  'tipCod' : tipCod,
                  'codbare' : codbare,
                  'codUmVolum' : codUmVolum,
                  'volum' : volum,
                  'codUmColet' : codUmColet,
                  'grbruta' : grbruta,
                  'grneta' : grneta,
                  'lotizat' : lotizat,
                  'zileraft' : zileraft,
                  'cantaribil' : cantaribil,
                  'codPart' : codPart,
				  'optext' : optext
                  ]
         
         def returnRowObj = null
         
         if (insert) {
            def argsNom = [locale, mapNom, stringFormat]
            def returnObjectNom = 
                      jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomService", "insert", argsNom)
            returnRowObj = returnObjectNom.remoteRowObject
         } else {
            def argsInsOrUpd = [codart, idFirma]
            
            def returnTemplateInsOrUpdate =
                      jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomService", "findNomRow", argsInsOrUpd)
            def templateInsorUpdate = returnTemplateInsOrUpdate.remoteRowObject
            
            if (debug) {
               println("Obiect Template pt. adaugare sau modificare: " + templateInsorUpdate)
            }
            
            if (templateInsorUpdate == null) {
               def argsNom = [locale, mapNom, stringFormat]
               def returnObjectNomIns = 
                         jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomService", "insert", argsNom)
               returnRowObj = returnObjectNomIns.remoteRowObject
            } else {
               mapNom = [:]
               mapNom<<returnTemplateInsOrUpdate.remoteSimpleObject
               mapNom<<[
                        'idFirma' : idFirma,
                        'idUseradg' : idUser,
                        'idUserdef' : idUser,
                        'datadef' : new java.util.Date(),
                        
                        'codart' : codart,
                        'numeart' : numeart,
                        'numesort' : numeart?.take(60),
                        'codUm' : codUm,
                        'codGrupa' : codGrupa,
                        'codSubgrupa' : codSubgrupa,
                        'codartEtalon' : codartEtalon,
                        'codTvaVnz' : codTvaVnz,
                        'tipTvaVnz' : tipTvaVnz,
                        'stocsig' : stocsig,
                        'tipCod' : tipCod,
                        'codbare' : codbare,
                        'codUmVolum' : codUmVolum,
                        'volum' : volum,
                        'codUmColet' : codUmColet,
                        'grbruta' : grbruta,
                        'grneta' : grneta,
                        'lotizat' : lotizat,
                        'zileraft' : zileraft,
                        'cantaribil' : cantaribil,
                        'codPart' : codPart,
						'optext' : optext
                        ]
               
               def argsNom = [locale, mapNom, stringFormat]
               def returnObjectNomUpd = 
                         jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomService", "update", argsNom)
               returnRowObj = returnObjectNomUpd.remoteRowObject
            }
         }
         
         if (returnRowObj == null) {
            suntErr = true
            randuriIgnorate++
            StringBuilder msgs = new StringBuilder()
            
            msgs<<"<mark>Set mesaje nr. <b>${randuriIgnorate + inregNecorespunzatoare}</b></mark> - Rand nr. <b>${nrRandDeAfisat}</b> / <b>${nrRandDeAfisat}</b>, Sheet (foaie) <b>${sheetName}</b>, fisier cu date de preluat / fisier <b>${numeFisErr}</b>:"
            
            if (existaMsgsErrorGetVal) {
               msgs<<"<br>"
               msgs<<msgsErrorGetVal.toString()
               
               msgs<<"<br>"
               msgs<<" "
            }
            
            msgs<<"<br>"
            msgs<<"<u>Incercarea de preluare a randului in Baza de Date</u>:"
            
            msgs<<"<br>"
            msgs<<"Eroare:"
            
            msgs<<"<br>"
            msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Randul a fost verificat, dar rezultatul <b>'returnRowObj'</b> este <b>null</b>. Prin urmare randul este ignorat si de la Adaugare, si de la Erori."
            
            msgs<<"<br>"
            msgs<<" "
            
            mesajeList<<msgs.toString()
            
            return
         }
         
         if (returnRowObj.containsErrors() || existaMsgsErrorGetVal || returnRowObj.containsWarnings()) {
            if (returnRowObj.containsErrors() || existaMsgsErrorGetVal) {
               suntErr = true
               inregNecorespunzatoare++
            }
             
            if (returnRowObj.containsWarnings()) {
               suntWrn = true
            }
            
            StringBuilder msgs = new StringBuilder()
            
            msgs<<"<mark>Set mesaje nr. <b>${randuriIgnorate + inregNecorespunzatoare}</b></mark> - Rand nr. <b>${nrRandDeAfisat}</b> / <b>${nrRandDeAfisat}</b>, Sheet (foaie) <b>${sheetName}</b>, fisier cu date de preluat / fisier <b>${numeFisErr}</b>:"
            
            if (existaMsgsErrorGetVal) {
               msgs<<"<br>"
               msgs<<msgsErrorGetVal.toString()
               
               msgs<<"<br>"
               msgs<<" "
            }
            
            msgs<<"<br>"
            msgs<<"<u>Incercarea de preluare a randului in Baza de Date</u>:"
            
            returnRowObj.messageList.each {emsMgs ->
               def titluMsgString = null
               
               switch (emsMgs.messageType) {
                case EmsysMessage.FATAL_ERROR_MESSAGE:
                 titluMsgString = "Eroare fatala"
                 break
                
                case EmsysMessage.ERROR_MESSAGE:
                 titluMsgString = "Eroare"
                 break
                
                case EmsysMessage.WARNING_MESSAGE:
                 titluMsgString = "Avertisment"
                 break
                
                case EmsysMessage.INFORMATION_MESSAGE:
                 titluMsgString = "Info"
                 return // break /* daca se doreste si afisarea mesajelor "Info") */
                
                default:
                 titluMsgString = "Mesaj"
                 return // break /* daca se doreste si afisarea mesajelor de alt tip decat cele de mai sus) */
               }
               
               if (emsMgs.field == null) {
                  msgs<<"<br>"
                  msgs<<"${titluMsgString}:"
                  
                  msgs<<"<br>"
                  msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> ${emsMgs.message}"
                  
                  msgs<<"<br>"
                  msgs<<" "
                  
                  if (debug) {
                     println("Obiect Mesaje Emsys: ${emsMgs}")
                     println("Mesaj Emsys: ${emsMgs.message}")
                  }
               } else {
                  def fiedlLabel = fields[emsMgs.field]
                  def rowField = rowFieldContext[emsMgs.field]
                  
                  msgs<<"<br>"
                  
                  if (rowField != null) {// Am pus aceasta conditie pt. a evita exceptia
                                         //   com.prodinf.core.util.groovy.ExcelReaderException:  Exception ::Cannot get property 'poiCell' on null object
                                         // care apare daca in fisier nu este completata coloana "Denumire";
                                         // in acest caz,
                                         // 'numesort' din mapNom (inexistent in fisier dar
                                         //                        introdus FORTAT in mapNom din cauza
                                         //                        MODULUI DE COMPLETARE a coloanei NOM.NumeSort
                                         //                        in "NomServiceImpl")
                                         // conduce la rowField == null si, deci, la exceptie pt. "rowField.poiCell".
                     
                     if (debug) {
                        println("rowField.poicell (la incercare preluare rand): ${rowField.poiCell}")
                     }
                     
                     def varPoicell = rowField.poiCell
                     
                     if (debug) {
                        println("varPoicell (la incercare preluare rand): ${varPoicell}")
                     }
                     
                     if (varPoicell != null) {// Am pus aceasta conditie pt. a evita exceptia
                                              //   com.prodinf.core.util.groovy.ExcelReaderException:  Exception ::Cannot invoke method setCellStyle() on null object
                                              // care apare daca in fisier nu sunt completate coloane cum ar fi:
                                              // "Cota TVA", "Se Cantareste" sau alte coloane obligatorii.
                        varPoicell.setCellStyle(style)
                     }
                     
                     msgs<<"${titluMsgString} la campul <b>${rowField.xlsField}</b> (coloana <b>${rowField.cell + 1}</b>, valoare citita <b>${rowField.value}</b>, valoare celula <b>${rowField.poiCell}</b>):"
                     
                     msgs<<"<br>"
                     msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> ${emsMgs.message}"
                  } else {
                     msgs<<"${titluMsgString} la campul <b>${fiedlLabel}</b>:"
                     
                     msgs<<"<br>"
                     msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> ${emsMgs.message}"
                  }
                  
                  msgs<<"<br>"
                  msgs<<" "
               }
            }
            
            mesajeList<<msgs.toString()
            } else {
               liniiOK<<rowNo
               inregAdaugate++
            }
            
            if (debug) {
               println("Obiectul contine erori ::: ${returnRowObj.containsErrors()}")
               println("Obiectul contine avertismente ::: ${returnRowObj.containsWarnings()}")
            }
      })
   } catch (error) {
      errFormatEronatFileNomArt = true
      
      fisRezSB<<"<li>"
      fisRezSB<<"Campul <mark><b>Fisier XLS conform model (NomArt.xlsx)</b></mark>:"
      
      fisRezSB<<"<br>"
      fisRezSB<<"Eroare:"
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Fisierul incarcat nu are format tabelar Excel (.XLSX, .XLS):"
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg} ${spatiiStangaMsg} ${spatiiStangaMsg}</span> <span style=\"color:DarkGrey;\">${error}</span>."
      
      fisRezSB<<"<br>"
      fisRezSB<<" "
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Fisierul incarcat trebuie sa aiba obligatoriu format tabelar Excel!"
      fisRezSB<<"</li>"
      
      fisRezSB<<"<br>"
   }
}

if (errLipsaFileNomArt || errFormatEronatFileNomArt) {
   fisRezSB<<"<b>Preluarea randurilor <mark>nu</mark> s-a realizat cu succes. <mark>Exista erori!</mark></b>"
   
   fisRezSB<<"</body></html>"
   
   fisRezFile.text = fisRezSB.toString()
   attachFile("Lista_Mesaje_pt_Informatii_Interfata.html", fisRezFile)
   
   return
}


if (debug) {
   println("mesajeList::: " + mesajeList)
}

if (debug) {
   println("Randuri corecte: ${liniiOK}")
}

liniiOK = liniiOK.reverse()

liniiOK.each {idx ->
   def cloneRow = cloneSheet.getRow(idx)
   cloneSheet.removeRow(cloneRow) // sterg doar continutul
                                  // !!! Se refera la faptul ca sterge continutul randului din fisier,
                                  // dar randul ramane ???
   if(idx + 1 > cloneSheet.lastRowNum) {
      //nu se mai face nimic
      return
   }
   
   cloneSheet.shiftRows(idx + 1, cloneSheet.lastRowNum, -1)
}

mesajeList.eachWithIndex {msg, index ->
   if (index > 0) {
      fisRezSB<<"<br>"
   }
   
   fisRezSB<<"<li>${msg.toString()}</li>"
}

if (suntErr || suntWrn) {
   fisRezSB<<"<br>"
}

fisRezSB<<"<p style=\"color:DodgerBlue;\"> <b>Inregistrari totale: ${inregTotale}</b> </p>"

if (insert) {
   fisRezSB<<"<p style=\"color:MediumSeaGreen;\"> <b>Inregistrari adaugate cu succes: ${inregAdaugate}</b> </p>"
} else {
   fisRezSB<<"<p style=\"color:MediumSeaGreen;\"> <b>Inregistrari adaugate / modificate cu succes: ${inregAdaugate}</b> </p>"
}

fisRezSB<<"<p style=\"color:Tomato;\"> <b>Inregistrari cu erori: ${inregNecorespunzatoare}</b> </p>"

fisRezSB<<"<p style=\"color:Grey;\"> <b>Randuri ignorate: ${randuriIgnorate}</b> </p>"

fisRezSB<<"<br>"

if (!suntErr) {
   if (!suntWrn) {
      fisRezSB<<"<b>Preluarea randurilor s-a realizat cu succes!</b>"
   } else {
      fisRezSB<<"<b>Preluarea randurilor s-a realizat cu succes, dar pentru anumite randuri exista <mark>avertismente</mark>.</b>"
   }
} else {
   fisRezSB<<"<b>Preluarea randurilor <mark>nu</mark> s-a realizat cu succes. <mark>Exista erori!</mark></b>"
   if (suntWrn) {
      fisRezSB<<"<br>"
      fisRezSB<<"<p><b>De asemenea, pentru anumite randuri exista <mark>avertismente</mark>.</b></p>"
   }
}

fisRezSB<<"</body></html>"

fisRezFile.text = fisRezSB.toString()
attachFile("Lista_Mesaje_Rezultate_Incercare_Preluare.html", fisRezFile)

if (suntErr) {
   File fisXLS = new File(tmpFolder,'errwwwws.xlsx')
   fisXLS.withOutputStream{os ->
      cloneWb.write(os)
   }
   attachFile(numeFisErr, fisXLS)
}


public void generateFieldDefinition(Locale locale, ErpGroovyTemplatesService.Definition definition) {
 def booleanFieldInsert = definition.addBooleanField('insert', 'Doar adaugare', true)
    .setToolTip('Daca este bifat se face doar Adaugare (Insert) altfel, daca exista inregistrarea, se face Modificare (Update)')
 
 definition.addUploadField('nomArt', 'Fisier XLS conform model (NomArt.xlsx)').setOrder(20)
}



import org.apache.poi.ss.usermodel.IndexedColors
import org.apache.poi.ss.usermodel.CellStyle
import org.apache.poi.ss.usermodel.BorderStyle
import org.apache.poi.ss.usermodel.FillPatternType
import org.apache.poi.hssf.usermodel.HSSFCellStyle
import java.math.RoundingMode
import com.prodinf.core.dataset.EmsysMessage